<template>
  <div>
    <h2 id="page-heading" data-cy="CuestionarioEstadoHeading">
      <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.home.title')" id="cuestionario-estado-heading">Cuestionario Estados</span>
      <div class="d-flex justify-content-end">
        <button class="btn btn-info mr-2" v-on:click="handleSyncList" :disabled="isFetching">
          <font-awesome-icon icon="sync" :spin="isFetching"></font-awesome-icon>
          <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.home.refreshListLabel')">Refresh List</span>
        </button>
        <router-link :to="{ name: 'CuestionarioEstadoCreate' }" custom v-slot="{ navigate }">
          <button
            @click="navigate"
            id="jh-create-entity"
            data-cy="entityCreateButton"
            class="btn btn-primary jh-create-entity create-cuestionario-estado"
          >
            <font-awesome-icon icon="plus"></font-awesome-icon>
            <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.home.createLabel')"> Create a new Cuestionario Estado </span>
          </button>
        </router-link>
      </div>
    </h2>
    <br />
    <div class="alert alert-warning" v-if="!isFetching && cuestionarioEstados && cuestionarioEstados.length === 0">
      <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.home.notFound')">No cuestionarioEstados found</span>
    </div>
    <div class="table-responsive" v-if="cuestionarioEstados && cuestionarioEstados.length > 0">
      <table class="table table-striped" aria-describedby="cuestionarioEstados">
        <thead>
          <tr>
            <th scope="row" v-on:click="changeOrder('id')">
              <span v-text="$t('global.field.id')">ID</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'id'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('valor')">
              <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.valor')">Valor</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'valor'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('valoracion')">
              <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.valoracion')">Valoracion</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'valoracion'"></jhi-sort-indicator>
            </th>
            <th scope="row" v-on:click="changeOrder('pregunta.pregunta')">
              <span v-text="$t('gatewayApp.pacientesCuestionarioEstado.pregunta')">Pregunta</span>
              <jhi-sort-indicator :current-order="propOrder" :reverse="reverse" :field-name="'pregunta.pregunta'"></jhi-sort-indicator>
            </th>
            <th scope="row"></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="cuestionarioEstado in cuestionarioEstados" :key="cuestionarioEstado.id" data-cy="entityTable">
            <td>
              <router-link :to="{ name: 'CuestionarioEstadoView', params: { cuestionarioEstadoId: cuestionarioEstado.id } }">{{
                cuestionarioEstado.id
              }}</router-link>
            </td>
            <td>{{ cuestionarioEstado.valor }}</td>
            <td>{{ cuestionarioEstado.valoracion }}</td>
            <td>
              <div v-if="cuestionarioEstado.pregunta">
                <router-link :to="{ name: 'PreguntaView', params: { preguntaId: cuestionarioEstado.pregunta.id } }">{{
                  cuestionarioEstado.pregunta.pregunta
                }}</router-link>
              </div>
            </td>
            <td class="text-right">
              <div class="btn-group">
                <router-link
                  :to="{ name: 'CuestionarioEstadoView', params: { cuestionarioEstadoId: cuestionarioEstado.id } }"
                  custom
                  v-slot="{ navigate }"
                >
                  <button @click="navigate" class="btn btn-info btn-sm details" data-cy="entityDetailsButton">
                    <font-awesome-icon icon="eye"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.view')">View</span>
                  </button>
                </router-link>
                <router-link
                  :to="{ name: 'CuestionarioEstadoEdit', params: { cuestionarioEstadoId: cuestionarioEstado.id } }"
                  custom
                  v-slot="{ navigate }"
                >
                  <button @click="navigate" class="btn btn-primary btn-sm edit" data-cy="entityEditButton">
                    <font-awesome-icon icon="pencil-alt"></font-awesome-icon>
                    <span class="d-none d-md-inline" v-text="$t('entity.action.edit')">Edit</span>
                  </button>
                </router-link>
                <b-button
                  v-on:click="prepareRemove(cuestionarioEstado)"
                  variant="danger"
                  class="btn btn-sm"
                  data-cy="entityDeleteButton"
                  v-b-modal.removeEntity
                >
                  <font-awesome-icon icon="times"></font-awesome-icon>
                  <span class="d-none d-md-inline" v-text="$t('entity.action.delete')">Delete</span>
                </b-button>
              </div>
            </td>
          </tr>
        </tbody>
        <infinite-loading
          ref="infiniteLoading"
          v-if="totalItems > itemsPerPage"
          :identifier="infiniteId"
          slot="append"
          @infinite="loadMore"
          force-use-infinite-wrapper=".el-table__body-wrapper"
          :distance="20"
        >
        </infinite-loading>
      </table>
    </div>
    <b-modal ref="removeEntity" id="removeEntity">
      <span slot="modal-title"
        ><span
          id="gatewayApp.pacientesCuestionarioEstado.delete.question"
          data-cy="cuestionarioEstadoDeleteDialogHeading"
          v-text="$t('entity.delete.title')"
          >Confirm delete operation</span
        ></span
      >
      <div class="modal-body">
        <p
          id="jhi-delete-cuestionarioEstado-heading"
          v-text="$t('gatewayApp.pacientesCuestionarioEstado.delete.question', { id: removeId })"
        >
          Are you sure you want to delete this Cuestionario Estado?
        </p>
      </div>
      <div slot="modal-footer">
        <button type="button" class="btn btn-secondary" v-text="$t('entity.action.cancel')" v-on:click="closeDialog()">Cancel</button>
        <button
          type="button"
          class="btn btn-primary"
          id="jhi-confirm-delete-cuestionarioEstado"
          data-cy="entityConfirmDeleteButton"
          v-text="$t('entity.action.delete')"
          v-on:click="removeCuestionarioEstado()"
        >
          Delete
        </button>
      </div>
    </b-modal>
  </div>
</template>

<script lang="ts" src="./cuestionario-estado.component.ts"></script>
